﻿Settings.CHECKED = 1;
Settings.UNCHECKED = 0;

Settings.FOLDER = "Folder";
Settings.SUBDIRECTORIES = "Subdirectories";
Settings.SPEED = "Speed";
Settings.EFFECT_ID = "EffectId";
Settings.SHUFFLE = "Shuffle";
Settings.BACKGROUND_COLOR = "BackgroundColor";

Settings.DEFAULT_FOLDER = System.Shell.knownFolderPath("pictures");
Settings.DEFAULT_SUBDIRECTORIES = Settings.UNCHECKED;
Settings.DEFAULT_SPEED = 60;
Settings.DEFAULT_EFFECT_ID = 12;
Settings.DEFAULT_SHUFFLE = Settings.CHECKED;
Settings.DEFAULT_BACKGROUND_COLOR = "#1BA0E1";

function Settings() {
    // Folder
    this.folder = System.Gadget.Settings.readString(Settings.FOLDER);
    if (this.folder == "" || this.folder.substr(this.folder.lastIndexOf(".")).toLowerCase() == ".zip") {
        this.folder = Settings.DEFAULT_FOLDER;
    }
    // Include Subdirectories
    this.includeSubdirectories =  parseInt(System.Gadget.Settings.readString(Settings.SUBDIRECTORIES));
    if (isNaN(this.includeSubdirectories)) {
        this.includeSubdirectories = Settings.DEFAULT_SUBDIRECTORIES;
    }
    this.includeSubdirectories = Boolean(this.includeSubdirectories);
    // Speed
    this.speed = parseInt(System.Gadget.Settings.readString(Settings.SPEED));
    if (isNaN(this.speed)) {
        this.speed = Settings.DEFAULT_SPEED;
    }
    // Effect Id
    this.effectId = parseInt(System.Gadget.Settings.readString(Settings.EFFECT_ID));
    if (isNaN(this.effectId)) {
        this.effectId = Settings.DEFAULT_EFFECT_ID;
    }
    // Shuffle
    this.shuffle = parseInt(System.Gadget.Settings.readString(Settings.SHUFFLE));
    if (isNaN(this.shuffle)) {
        this.shuffle = Settings.DEFAULT_SHUFFLE;
    }
    this.shuffle = Boolean(this.shuffle);
    // Background
    this.backgroundColor = System.Gadget.Settings.readString(Settings.BACKGROUND_COLOR);
    if (this.backgroundColor == "") {
        this.backgroundColor = Settings.DEFAULT_BACKGROUND_COLOR;
    }
}

Settings.prototype.save = function () {
    System.Gadget.Settings.writeString(Settings.FOLDER, this.folder);
    System.Gadget.Settings.writeString(Settings.SUBDIRECTORIES, this.includeSubdirectories);
    System.Gadget.Settings.writeString(Settings.SPEED, this.speed);
    System.Gadget.Settings.writeString(Settings.EFFECT_ID, this.effectId);
    System.Gadget.Settings.writeString(Settings.SHUFFLE, this.shuffle);
    System.Gadget.Settings.writeString(Settings.BACKGROUND_COLOR, this.backgroundColor);
};