﻿var L_ERROR_MESSAGE = "Error";
var L_NO_IMAGES_MESSAGE = "No images";
var L_PLAY = "<img src='../images/play.png' alt='Play (Enter)'/>";
var L_PAUSE = "<img src='../images/pause.png' alt='Pause (Space)'/>";

var FILE_TYPES = new Array(".jpg", ".jpeg", ".jpe", ".gif", ".png", ".bmp");

var _settings;

var _arrImages;
var _index;
var _image;
var _timer;
var _isPlaing;

System.Gadget.settingsUI = "settingsDialog.html";
System.Gadget.onSettingsClosed = SettingsClosed;
System.Gadget.visibilityChanged = CheckVisibility;

function init() 
{
    _settings = new Settings();
    metroUISlideShow.style.backgroundColor = _settings.backgroundColor;
    pictureFrameMessage.innerText = "";
    _arrImages = new Array();
    _index = 0;
    selectImages(_settings.folder);
    _isPlaing = true;
    link_play_pause.innerHTML = L_PAUSE;
}

function selectImages(folderPath) 
{
    try 
    {
        var folderObj = System.Shell.itemFromPath(folderPath);
    }
    catch (e) 
    {
        pictureFrameMessage.innerText = L_ERROR_MESSAGE;
    }
    var folderItems = folderObj.SHFolder.Items;
    folderObj = null;
    var itemsCount = folderItems.count;
    for (var i = 0; i < itemsCount; i++) {
        var curItem = folderItems.item(i);
        var curPath = curItem.path;
        var extension = curPath.substr(curPath.lastIndexOf(".")).toLowerCase();
        // Include Subdirectories
        if (_settings.includeSubdirectories && curItem.isFolder && extension != ".zip") 
        {            
            selectImages(curPath);            
        }
        else
        {
            for (var j = 0; j < FILE_TYPES.length; j++) 
            {
                if (extension == FILE_TYPES[j]) 
                {
                    _arrImages.push(curPath);
                    break;
                }
            }
        }
    }    
    if (_settings.shuffle) 
    {
        shuffle(_arrImages);
    }
}

// Fisher-Yates shuffle algorithm
function shuffle(arr) 
{
    var i = arr.length;
    if (i == 0) return;
    while (--i) 
    {
        var j = Math.floor(Math.random() * (i + 1));
        var tempi = arr[i];
        var tempj = arr[j];
        arr[i] = tempj;
        arr[j] = tempi;   
    }
}

function loadImage() 
{
    if (_index >= _arrImages.length) 
    {
        _index = 0;
    }
    if (_index < 0)
    {
        _index = _arrImages.length - 1;
    }
    if (_arrImages.length > 0) 
    {
        _image = _arrImages[_index];
            try
            {
                System.Shell.itemFromPath(_image);
                pictureFrameMessage.innerText = "";
                _index++;
            }
            catch (e) 
            {
                _image = System.Gadget.path + "\\images\\tulips.jpg";
                _index++;
                pictureFrameMessage.innerText = L_ERROR_MESSAGE;
            }            
    }
    else 
    {
        _image = System.Gadget.path + "\\images\\tulips.jpg";
        pictureFrameMessage.innerText = L_NO_IMAGES_MESSAGE;
        return;
    }
    // Picture
    picture.src = "gimage:///" + encodeURIComponent(_image) + "?width=230&height=110";
    link_browse.href = "file:///" + _image;
    // Slide Effect
    if (_settings.effectId != -1) 
    {
        pictureFrame.filters(_settings.effectId).Apply();
        pictureFrame.filters(_settings.effectId).Play();
    }
}

function nextImage() {
    loadImage();
    // Check _isPlaing flag
    if (_isPlaing) {
        clearTimeout(_timer);
        _timer = setTimeout("nextImage()", _settings.speed * 1000);
    }
}

function previousImage() {
    _index -= 2;
    nextImage();
}

function playPause() {
    if (_isPlaing) {
        _isPlaing = false;
        link_play_pause.innerHTML = L_PLAY;
        clearTimeout(_timer);

    }
    else {
        _isPlaing = true;
        link_play_pause.innerHTML = L_PAUSE;
        nextImage();
    }
}

function keyNavigate() {
    switch (event.keyCode) {
        case 37:    // Arrow Left          
        case 100:   // 4 (Num Lock)
            previousImage();
            break;
        case 39:    // Arrow Right
        case 102:   // 6 (Num Lock)
            nextImage();
            break;
        case 13:    // Enter
            playPause();
            break;
    }
}

// --------------------------------------------------------------------
// Handle the Settings dialog closed event.
// event = System.Gadget.Settings.ClosingEvent argument.
// --------------------------------------------------------------------
function SettingsClosed(event) {
    if (event.closeAction == event.Action.commit) {
        init();
        nextImage();
    }
}

// --------------------------------------------------------------------
// Handle the gadget visiblity changed event.
// event = Event argument.
// --------------------------------------------------------------------
function CheckVisibility(event) {
    if(_isPlaing) {
        if (System.Gadget.visible) {
            if(!_timer) {
                nextImage();
            }
        }
        else {
            clearTimeout(_timer);
            _timer = null;
        }
    }
}

function updateFolder() {
    var oItem = System.Shell.itemFromFileDrop(event.dataTransfer, 0);
    if (oItem.isFolder) {
        _settings.folder = oItem.path;
        _settings.save();
        init();
        nextImage();
    }
}

function showNavBar()
{
    clearTimeout(navBarFrame.timer);
    show();
}

function show() {
    with (navBarFrame.filters("alpha")) 
    {
        if ((opacity += 10) < 100) 
        {
            navBarFrame.timer = setTimeout(show, 50);
        }
        else 
        {
            clearTimeout(navBarFrame.timer);
            opacity = 100;
        }
    }
}

function hideNavBar() 
{
    clearTimeout(navBarFrame.timer);
    hide();
}

function hide()
{
    with (navBarFrame.filters("alpha")) {
        if ((opacity -= 10) > 0) 
        {
            navBarFrame.timer = setTimeout(hide, 50); 
        }
        else 
        {
            clearTimeout(navBarFrame.timer);                
            opacity = 0;
        }
    }
}