﻿var L_NONE_TEXT = "Нет";
var L_BARN_TEXT = "Амбар";
var L_BLINDS_TEXT = "Жалюзи";
var L_CHECKERBOARD_TEXT = "Шахматная доска";
var L_DISSOLVE_TEXT = "Растворение";
var L_FADE_TEXT = "Угасание";
var L_INSET_TEXT = "Вовнутрь";
var L_PLUS_TEXT = "Плюс";
var L_PIXELATE_TEXT = "Точечное";
var L_RADIALWIPE_TEXT = "Лучевое стирание";
var L_RADIALWIPE_TEXT = "Радиальное стирание";
var L_RANDOM_BARS_TEXT = "Случайные полосы";
var L_RANDOM_DISSOLVER_TEXT = "Случайное растворение";
var L_SLIDE_HIDE_TEXT = "Слайд - Спрятать";
var L_SLIDE_PUSH_TEXT = "Слайд - Вытеснить";
var L_SLIDE_SWAP_TEXT = "Слайд - Заменить";
var L_SPIRAL_TEXT = "Виток";
var L_STRETCH_HIDE_TEXT = "Растяжение - Спрятать";
var L_STRETCH_PUSH_TEXT = "Растяжение - Вытеснить";
var L_STRETCH_SPIN_TEXT = "Растяжение - Переплести";
var L_WIPE_TEXT = "Стирание";
var L_WHEEL_TEXT = "Колесо";
var L_ZIGZAG_TEXT = "Зигзаг";


var L_SECONDS_TEXT = "сек.";
var L_MINUTES_TEXT = "мин.";
var L_MINUTE_TEXT = "мин.";

var L_MAGENTA_TEXT = "Пурпурный";
var L_PURPLE_TEXT = "Сиреневый";
var L_TEAL_TEXT = "Бирюзовый";
var L_LIME_TEXT = "Лайм";
var L_BROWN_TEXT = "Коричневый";
var L_PINK_TEXT = "Розовый";
var L_ORANGE_TEXT = "Оранжевый";
var L_BLUE_TEXT = "Голубой";
var L_RED_TEXT = "Красный";
var L_GREEN_TEXT = "Зеленый";

var L_CHOOSEFOLDER_TEXT = "Показывать изображения из этой папки во время показа слайдов:";

var _settings;

// Delegate for the settings closing event.
System.Gadget.onSettingsClosing = SettingsClosing;

function init() {
    _settings = new Settings();

    var arrSlideTime = new Array(
            ["5 " + L_SECONDS_TEXT, 5],
            ["10 " + L_SECONDS_TEXT, 10],
            ["15 " + L_SECONDS_TEXT, 15],
            ["30 " + L_SECONDS_TEXT, 30],
            ["1 " + L_MINUTE_TEXT, 60],
            ["2 " + L_MINUTES_TEXT, 120],
            ["5 " + L_MINUTES_TEXT, 300]);

    var arrEffectName = new Array(
        L_BARN_TEXT,
        L_BLINDS_TEXT,
        L_CHECKERBOARD_TEXT,
        L_DISSOLVE_TEXT,
        L_FADE_TEXT,
        L_INSET_TEXT,
        L_PLUS_TEXT,
        L_PIXELATE_TEXT,
        L_RADIALWIPE_TEXT,
        L_RANDOM_BARS_TEXT,
        L_RANDOM_DISSOLVER_TEXT,
        L_SLIDE_HIDE_TEXT,
        L_SLIDE_PUSH_TEXT,
        L_SLIDE_SWAP_TEXT,
        L_SPIRAL_TEXT,
   	    L_STRETCH_HIDE_TEXT,
        L_STRETCH_PUSH_TEXT,
        L_STRETCH_SPIN_TEXT,
        L_WIPE_TEXT,
        L_WHEEL_TEXT,
        L_ZIGZAG_TEXT);

    var arrColors = new Array(
            [L_MAGENTA_TEXT, "#FE0096"],
            [L_PURPLE_TEXT, "#A201FF"],
            [L_TEAL_TEXT, "#01ABAA"],
            [L_LIME_TEXT, "#8CBF26"],
            [L_BROWN_TEXT, "#9A6600"],
            [L_PINK_TEXT, "#E671B8"],
            [L_ORANGE_TEXT, "#F09709"],
            [L_BLUE_TEXT, "#1BA0E1"],
            [L_RED_TEXT, "#E51400"],
            [L_GREEN_TEXT, "#339933"]);
    
    // Folder
    txtFolder.value = _settings.folder;
    // Subdirectories
    checkboxSubdirectories.checked = _settings.includeSubdirectories;
    // Speed
    for (var i = 0; i < arrSlideTime.length; i++) {
        selectSpeed.options.add(new Option(arrSlideTime[i][0], arrSlideTime[i][1]));
    }
    selectSpeed.value = _settings.speed;
    // Effect Id
    selectEffect.options.add(new Option(L_NONE_TEXT, -1));
    for (var i = 0; i < arrEffectName.length; i++) {
        selectEffect.options.add(new Option(arrEffectName[i], i));
    }
    selectEffect.value = _settings.effectId;
    // Shuffle
    checkboxShuffle.checked = _settings.shuffle;
    // Background
    for (var i = 0; i < arrColors.length; i++) {
        selectBackgroundColor.options.add(new Option(arrColors[i][0], arrColors[i][1]));
    }
    selectBackgroundColor.value = _settings.backgroundColor;

    ver.innerText = System.Gadget.name + " " + System.Gadget.version;
}

function browseFolder() {
    var shellFolder = System.Shell.chooseFolder(L_CHOOSEFOLDER_TEXT, 50);
    if (shellFolder) {
        txtFolder.value = shellFolder.path;
    }
}

// --------------------------------------------------------------------
// Handle the Settings dialog closing event.
// Parameters:
// event - event arguments.
// --------------------------------------------------------------------
function SettingsClosing(event) {
    // Save the settings if the user clicked OK.
    if (event.closeAction == event.Action.commit) {
        _settings.folder = txtFolder.value;
        _settings.includeSubdirectories = checkboxSubdirectories.checked ? Settings.CHECKED : Settings.UNCHECKED;
        _settings.speed = selectSpeed.value;
        _settings.effectId = selectEffect.value;
        _settings.shuffle = checkboxShuffle.checked ? Settings.CHECKED : Settings.UNCHECKED;
        _settings.backgroundColor = selectBackgroundColor.value;
        _settings.save();
    }
    // Allow the Settings dialog to close.
    event.cancel = false;
}